<?php
class ControllerExtensionPaymentipay88AtmTransfer extends Controller
{
    public function index()
    {
		$this->load->language('extension/payment/ipay88AtmTransfer');
				
        $data['button_confirm'] = $this->language->get('button_confirm');
        $data['continue'] 		= $this->url->link('checkout/success');	
		
		//ACTION
		$data['action'] 					= $this->config->get('payment_ipay88AtmTransfer_action');
		
		//METHOD TITLE
		$data['title']						= $this->config->get('payment_ipay88AtmTransfer_method_title');
		
		//DESCRIPTION
		$data['ipay88_description'] 		= $this->config->get('payment_ipay88AtmTransfer_description');
					
					
		//MAYBANK VA
		$data['ipay88_maybank_va']			= $this->config->get('payment_ipay88AtmTransfer_maybank_va');
		
		//MAYBANK VA LOGO
		$data['ipay88_maybank_va_logo'] 	= '<img src="catalog/view/theme/default/image/ipay88_maybank_va_logo.png" alt="iPay88" title="iPay88" style="vertical-align:middle"/>';
		
		//MANDIRI ATM
		$data['ipay88_mandiri_atm'] 		= $this->config->get('payment_ipay88AtmTransfer_mandiri_atm');
		
		//MANDIRI ATM LOGO
		$data['ipay88_mandiri_atm_logo']	= '<img src="catalog/view/theme/default/image/ipay88_mandiri_atm_logo.png" alt="iPay88" title="iPay88" style="vertical-align:middle"/>';	
		
		//BCA VA
		$data['ipay88_bca_va'] 				= $this->config->get('payment_ipay88AtmTransfer_bca_va');
		
		//BCA VA LOGO
		$data['ipay88_bca_va_logo']			= '<img src="catalog/view/theme/default/image/ipay88_bca_va_logo.png" alt="iPay88" title="iPay88" style="vertical-align:middle"/>';
		
		//BNI VA
		$data['ipay88_bni_va'] 				= $this->config->get('payment_ipay88AtmTransfer_bni_va');
		
		//BNI VA LOGO
		$data['ipay88_bni_va_logo']			= '<img src="catalog/view/theme/default/image/ipay88_bni_va_logo.png" alt="iPay88" title="iPay88" style="vertical-align:middle"/>';		
		
		//PERMATA ATM
		$data['ipay88_permata_atm'] 		= $this->config->get('payment_ipay88AtmTransfer_permata_atm');
		
		//PERMATA ATM LOGO
		$data['ipay88_permata_atm_logo']	= '<img src="catalog/view/theme/default/image/ipay88_permata_atm_logo.png" alt="iPay88" title="iPay88" style="vertical-align:middle"/>';	
				
		//PERMATA VA
		$data['ipay88_permata_va'] 			= $this->config->get('payment_ipay88AtmTransfer_permata_va');
		
		//PERMATA VA LOGO
		$data['ipay88_permata_va_logo']		= '<img src="catalog/view/theme/default/image/ipay88_permata_va_logo.png" alt="iPay88" title="iPay88" style="vertical-align:middle"/>';	
		
		
		//Load Model
		$this->load->model('checkout/order');
		
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
				
		//PRODUCT
		$products = $this->cart->getProducts();
        
		foreach ($products as $product) 
		{
            $data['prod_desc'][] = " ".$product['name']." x ".$product['quantity'].", ";
        }
		
		$product_description = rtrim(implode($data['prod_desc']), ", ");	
				
		//HASH AMOUNT
		$total 			= $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
		$orderAmount	= number_format($total, 2, ".", "");
	    $HashAmount 	= str_replace(".","",str_replace(",","",$orderAmount));	
		
		
		//DATE HIS
		date_default_timezone_set('Asia/Jakarta');	
			
				
		//SIGNATURE
		$MechantKey 	= $this->config->get('payment_ipay88AtmTransfer_merchant_key');
		$MerchantCode 	= $this->config->get('payment_ipay88AtmTransfer_merchant_code');
		$RefNo			= $this->session->data['order_id']; 
		$Amount			= $HashAmount; 
		$Currency		= $order_info['currency_code'];
		$ipaySignature 	= "";
		
		$encrypt		= sha1($MechantKey.$MerchantCode.$RefNo.$Amount.$Currency);		
		
		for ($i=0; $i<strlen($encrypt); $i=$i+2)
		{
			$ipaySignature .= chr(hexdec(substr($encrypt,$i,2)));
		}
     	
		$ipaySignature = base64_encode($ipaySignature);
		
		//iPay88 Params
		$data['MerchantCode'] 	= $MerchantCode;
		$data['RefNo'] 			= $RefNo;
		$data['Amount'] 		= $HashAmount;
		$data['Currency'] 		= $Currency;
		$data['ProdDesc'] 		= $product_description;
		$data['UserName'] 		= $order_info['payment_firstname'] . ' ' . $order_info['payment_lastname'];
		$data['UserEmail'] 		= $order_info['email'];
		$data['UserContact'] 	= $order_info['telephone'];
		$data['Remark'] 		= "Transaction date".date('Y-m-d H:i:s');
		$data['Lang'] 			= "UTF-8";
		$data['Signature'] 		= $ipaySignature;
		$data['ipay88_action'] 	= $this->config->get('ipay88_action');
		$data['ResponseURL'] 	= $this->url->link('extension/payment/ipay88AtmTransfer/ipay88_response', '', 'SSL');
		$data['BackendURL'] 	= $this->url->link('extension/payment/ipay88AtmTransfer/ipay88_backend', '', 'SSL');
		
		//Message
		$this->model_checkout_order->addOrderHistory($RefNo, 1, "iPay88 Payment Pending. iPay88 payment window page is being / has been ACCESSED. Quantity reduced for ".$product_description.".", true);	
				
        return $this->load->view('extension/payment/ipay88AtmTransfer', $data);
    }
	
	    
    public function ipay88_response()
   	{
		//-----Sepay
        $this->load->language('extension/payment/ipay88AtmTransfer');
        $this->document->setTitle($this->language->get('text_payment_title'));
     
        $data['column_left'] 	= $this->load->controller('common/column_left');
        $data['column_right'] 	= $this->load->controller('common/column_right');
        $data['content_top']	= $this->load->controller('common/content_top');
        $data['content_bottom'] = $this->load->controller('common/content_bottom');
        $data['footer'] 		= $this->load->controller('common/footer');
        $data['header'] 		= $this->load->controller('common/header');
		//-----End Sepay
	
		
		if (isset($_REQUEST['RefNo'])) 
		{
			//Load Model
	  		$this->load->model('checkout/order');
			$this->load->model('catalog/product');
		
			//Get reference number response
			$RefNo_response = trim(stripslashes($_REQUEST['RefNo']));
						
			$order_info = $this->model_checkout_order->getOrder($RefNo_response);			
			
			$products 	= $this->model_checkout_order->getOrderProducts($RefNo_response);
			
			foreach ($products as $product) 
			{
				$data['prod_desc'][] = " ".$product['name']." x ".$product['quantity'].", ";
			}
			
			$product_description = rtrim(implode($data['prod_desc']), ", ");
				
			//Trans ID + error response
			$error_response         = $_REQUEST['ErrDesc'];
			$transid_response		= $_REQUEST['TransId'];	
						
			//Get signature response
			$signature_response		= $_REQUEST['Signature'];
			
			//Generate signature		
			$MechantKey_response 	= $this->config->get('payment_ipay88AtmTransfer_merchant_key');
			$MerchantCode_response 	= $this->config->get('payment_ipay88AtmTransfer_merchant_code');
			$PaymentId_response		= $_REQUEST['PaymentId'];
			$HashAmount_response 	= str_replace(array(',','.'), "", $_REQUEST['Amount']);
			$Currency_response 		= $_REQUEST['Currency'];
			$Status_response 		= $_REQUEST['Status'];
			
			$merchant_signature		= "";
		
			$merchant_encrypt		= sha1($MechantKey_response.$MerchantCode_response.$PaymentId_response.$RefNo_response.$HashAmount_response.$Currency_response.$Status_response);		
		
			for ($i=0; $i<strlen($merchant_encrypt); $i=$i+2)
			{	
				$merchant_signature .= chr(hexdec(substr($merchant_encrypt,$i,2)));
			}
     	
			$merchant_signature_check = base64_encode($merchant_signature);
			
			//Payment success and signature match
			if ($_REQUEST['Status']=="1" && $merchant_signature_check==$signature_response) 
			{							
				$this->response->redirect($this->url->link('checkout/success', '', true));		
				//$this->response->redirect($this->url->link('checkout/success'));	
			}
			
			//Payment pending and signature match
			elseif ($_REQUEST['Status']=="6" && $merchant_signature_check==$signature_response) 
			{
				
				$this->cart->clear();
		
				unset($this->session->data['shipping_method']);
				unset($this->session->data['shipping_methods']);
				unset($this->session->data['payment_method']);
				unset($this->session->data['payment_methods']);
				unset($this->session->data['guest']);
				unset($this->session->data['comment']);
				unset($this->session->data['order_id']);
				unset($this->session->data['coupon']);
				unset($this->session->data['reward']);
				unset($this->session->data['voucher']);
				unset($this->session->data['vouchers']);
				unset($this->session->data['totals']);
								
				$data['breadcrumbs'] = array();

				$data['breadcrumbs'][] = 
				array(
						'text' => $this->language->get('text_home'),
						'href' => $this->url->link('common/home')
				);
		
				$data['breadcrumbs'][] = 
				array(
					'text' => $this->language->get('text_basket'),
					'href' => $this->url->link('checkout/cart')
				);
		
				$data['breadcrumbs'][] = 
				array(
					'text' => $this->language->get('text_checkout'),
					'href' => $this->url->link('checkout/checkout', '', true)
				);
		
				$data['breadcrumbs'][] = 
				array(
					'text' => $this->language->get('text_pending'),
					'href' => $this->url->link('common/home')
				);
											
				
				if ($this->customer->isLogged()) 
				{
					$data['text_message'] = sprintf($this->language->get('text_customer'), $this->url->link('account/account', '', true), $this->url->link('account/order', '', true), $this->url->link('account/download', '', true), $this->url->link('information/contact'));
				} 
				
				else 
				{
					$data['text_message'] = sprintf($this->language->get('text_guest'), $this->url->link('information/contact'));
				}
				
				
				if ($PaymentId_response == "9") 
				{
					$data['documentation'] = 
					'https://payment.ipay88.co.id/epayment/documentation/Pembayaran-untuk-Maybank-Virtual-Account.pdf';
					
					$data['text_payment_type'] = "Maybank VA";
				}
				
				if ($PaymentId_response == "17") 
				{
					$data['documentation'] = 
					'https://payment.ipay88.co.id/epayment/documentation/Panduan-Pembayaran-untuk-Mandiri-ATM-Automatic.pdf';
					
					$data['text_payment_type'] = "Mandiri ATM";
				}
				
				
				$data['continue'] = $this->url->link('common/home');
				
           	 	$this->response->setOutput($this->load->view('extension/payment/ipay88AtmTransfer_pending', $data));
			}
		
			//Payment failed
			else 
			{
				//Increase quantitiy				
				$order_products = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_product WHERE order_id = '".(int)$RefNo_response."'");
					
				foreach($order_products->rows as $order_product) 
				{					
					$this->db->query("UPDATE ".DB_PREFIX."product SET quantity = (quantity + " . (int)$order_product['quantity'] . ") WHERE product_id = '" . (int)$order_product['product_id'] . "' AND subtract = '1'");
					
					$order_product_id 	= $order_product['order_product_id'];
					$order_options 		= $this->db->query("SELECT * FROM " . DB_PREFIX . "order_option WHERE order_id = '" . (int)$RefNo_response . "' AND order_product_id = '" . (int)$order_product_id . "'");

					foreach ($order_options->rows as $order_option) 
					{
						$this->db->query("UPDATE " . DB_PREFIX . "product_option_value SET quantity = (quantity + " . (int)$order_product['quantity'] . ") WHERE product_option_value_id = '" . (int)$order_option['product_option_value_id'] . "' AND subtract = '1'");
					}
				}
				
							
				//Message
				$this->model_checkout_order->addOrderHistory($RefNo_response, 10, "iPay88 Payment Failed. Error description: ".$error_response.". Transaction ID: ".$transid_response.". Quantity increased for ".$product_description.".", true);	
												
				//$data['checkout_link'] = $this->url->link('checkout/checkout', '', true);
           	 	//$this->response->setOutput($this->load->view('extension/payment/ipay88AtmTransfer_failed', $data));
				
				$data['continue'] = $this->url->link('common/home');
				
				$this->response->redirect($this->url->link('checkout/failure', '', true));				
			}
				
		}
			
		else
		{
			$this->cart->clear();

			unset($this->session->data['shipping_method']);
			unset($this->session->data['shipping_methods']);
			unset($this->session->data['payment_method']);
			unset($this->session->data['payment_methods']);
			unset($this->session->data['guest']);
			unset($this->session->data['comment']);
			unset($this->session->data['order_id']);	
			unset($this->session->data['coupon']);
			unset($this->session->data['reward']);
			unset($this->session->data['voucher']);
			unset($this->session->data['vouchers']);	 
		
			$this->response->redirect($this->url->link('common/home'));
		}
    }
	
	
	public function ipay88_backend() 
	{
		//-----Sepay
       $this->load->language('extension/payment/ipay88AtmTransfer');
        $this->document->setTitle($this->language->get('text_payment_title'));
     
        $data['column_left'] 	= $this->load->controller('common/column_left');
        $data['column_right'] 	= $this->load->controller('common/column_right');
        $data['content_top']	= $this->load->controller('common/content_top');
        $data['content_bottom'] = $this->load->controller('common/content_bottom');
        $data['footer'] 		= $this->load->controller('common/footer');
        $data['header'] 		= $this->load->controller('common/header');
		//-----End Sepay
		
	  							
		if (isset($_REQUEST['RefNo'])) 
		{
			//Load Model
	  		$this->load->model('checkout/order');
			$this->load->model('catalog/product');
					
			//Get reference number response
			$RefNo_response = trim(stripslashes($_REQUEST['RefNo']));
				
			$order_info = $this->model_checkout_order->getOrder($RefNo_response);			
			
			$products 	= $this->model_checkout_order->getOrderProducts($RefNo_response);
			
			foreach ($products as $product) 
			{
				$data['prod_desc'][] = " ".$product['name']." x ".$product['quantity'].", ";
			}
			
			$product_description = rtrim(implode($data['prod_desc']), ", ");
						
			//Trans ID + Error
			$transid_response = $_REQUEST['TransId'];
			$error_response   = $_REQUEST['ErrDesc'];
				
			//Get signature response
			$signature_response		= $_REQUEST['Signature'];	
			
			//Generate signature
			$MechantKey_response 	= $this->config->get('payment_ipay88AtmTransfer_merchant_key');
			$MerchantCode_response 	= $this->config->get('payment_ipay88AtmTransfer_merchant_code');
			$PaymentId_response		= $_REQUEST['PaymentId'];
			$RefNo_response 		= trim(stripslashes($_REQUEST['RefNo']));
			$HashAmount_response 	= str_replace(array(',','.'), "", $_REQUEST['Amount']);
			$Currency_response 		= $_REQUEST['Currency'];
			$Status_response 		= $_REQUEST['Status'];
			
			$merchant_signature		= "";
		
			$merchant_encrypt		= sha1($MechantKey_response.$MerchantCode_response.$PaymentId_response.$RefNo_response.$HashAmount_response.$Currency_response.$Status_response);		
		
			for ($i=0; $i<strlen($merchant_encrypt); $i=$i+2)
			{	
				$merchant_signature .= chr(hexdec(substr($merchant_encrypt,$i,2)));
			}
     	
			$merchant_signature_check = base64_encode($merchant_signature);
			
			//Receive OK
			if ($_REQUEST['Status']=="1" && $merchant_signature_check==$signature_response) 
			{
				//Message
				$this->model_checkout_order->addOrderHistory($RefNo_response, 2, "iPay88 Payment Completed. Status: ".$Status_response.". Transaction ID: ".$transid_response.".", true);		
								
				$this->response->setOutput($this->load->view('extension/payment/ipay88AtmTransfer_backend_success', $data));
			}
			
			//Pending
			if ($_REQUEST['Status']=="6" && $merchant_signature_check==$signature_response) 
			{
				//Message
				$this->model_checkout_order->addOrderHistory($RefNo_response, 1, "iPay88 Payment Pending. Transaction ID: ".$transid_response.".", true);		
								
				$this->response->setOutput($this->load->view('extension/payment/ipay88AtmTransfer_backend_pending', $data));
			}
		
			//Backend failed
			if ($_REQUEST['Status']=="0") 
			{				
				//Increase quantitiy				
				$order_products = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_product WHERE order_id = '".(int)$RefNo_response."'");
					
				foreach($order_products->rows as $order_product) 
				{					
					$this->db->query("UPDATE ".DB_PREFIX."product SET quantity = (quantity + " . (int)$order_product['quantity'] . ") WHERE product_id = '" . (int)$order_product['product_id'] . "' AND subtract = '1'");
					
					$order_product_id 	= $order_product['order_product_id'];
					$order_options 		= $this->db->query("SELECT * FROM " . DB_PREFIX . "order_option WHERE order_id = '" . (int)$RefNo_response . "' AND order_product_id = '" . (int)$order_product_id . "'");

					foreach ($order_options->rows as $order_option) 
					{
						$this->db->query("UPDATE " . DB_PREFIX . "product_option_value SET quantity = (quantity + " . (int)$order_product['quantity'] . ") WHERE product_option_value_id = '" . (int)$order_option['product_option_value_id'] . "' AND subtract = '1'");
					}
				}
				
				
				//Message
				$this->model_checkout_order->addOrderHistory($RefNo_response, 10, "iPay88 Payment Failed. Error description: ".$error_response.". Transaction ID: ".$transid_response.". Quantity increased for ".$product_description.".", true);	
						
				$this->response->setOutput($this->load->view('extension/payment/ipay88AtmTransfer_backend_failed', $data));
			}	
				
		}
			
		else
		{
			$this->cart->clear();

			unset($this->session->data['shipping_method']);
			unset($this->session->data['shipping_methods']);
			unset($this->session->data['payment_method']);
			unset($this->session->data['payment_methods']);
			unset($this->session->data['guest']);
			unset($this->session->data['comment']);
			unset($this->session->data['order_id']);	
			unset($this->session->data['coupon']);
			unset($this->session->data['reward']);
			unset($this->session->data['voucher']);
			unset($this->session->data['vouchers']);	 
		
			$this->response->redirect($this->url->link('common/home'));
		}		
	}
	
}